with Video.Colors;
with Video.Integer_Geometry;

procedure Example_Scene (R : in out Video.Renderables.Color.Curve_Renderable'Class) is
	BB : constant Video.Integer_Geometry.Box := R.Bounding_Box;
	Center : constant Video.Integer_Geometry.Point := Video.Integer_Geometry.Center (BB);
begin
	R.Clear (Video.Colors.RGB_8 (0, 0, 0));

	R.Fill_Rectangle (
		Bounds => ((200, 400), (200, 300)),
		Paint  => Video.Colors.RGB_8 (16#FA#, 16#CE#, 16#8D#));

	for Y in 0 .. 255 loop
		for X in 0 .. 255 loop
			R.Write_Pixel (
				A => (X, Y),
				Paint => Video.Colors.RGB_8 (X, Y, 255 - (X + Y) / 2));
		end loop;
	end loop;

	for X in BB.X.First / 8 .. BB.X.Last / 8 loop
		R.Line (
			A => Center,
			B => (X * 8, BB.Y.Last),
			Paint => Video.Colors.Hex_6 (16#FFFFFF#));
	end loop;

	for X in 0 .. 10 loop
		R.Circle ((Center.X, Center.Y), X * 10,
		          Paint => Video.Colors.Hex_6 (16#FF00FF#));
	end loop;

	for X in 0 .. 10 loop
		R.Ellipse (((Center.X - X * 20,       Center.X + X * 20),
		            (Center.Y - 200 + X * 20, Center.Y + 200 - X * 20)),
		           Paint => Video.Colors.Hex_6 (16#00FFFF#));
	end loop;

end Example_Scene;
